/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : tss1.c
**     Project     : S32K148_Based_T_BOX_BSP_TestPrj_SDK_RTM2_0
**     Processor   : S32K148_144
**     Component   : tss
**     Version     : Component SDK_S32K14x_12, Driver 01.00, CPU db: 3.00.000
**     Repository  : SDK_S32K14x_12
**     Compiler    : GNU C Compiler
**     Date/Time   : 2018-11-02, 13:30, # CodeGen: 89
**
**     Copyright 1997 - 2015 Freescale Semiconductor, Inc.
**     Copyright 2016-2017 NXP
**     All Rights Reserved.
**     
**     THIS SOFTWARE IS PROVIDED BY NXP "AS IS" AND ANY EXPRESSED OR
**     IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
**     OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
**     IN NO EVENT SHALL NXP OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
**     INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
**     SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
**     HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
**     STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
**     IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
**     THE POSSIBILITY OF SUCH DAMAGE.
** ###################################################################*/
/*!
** @file tss1.c
** @version 01.00
*/
/*!
**  @addtogroup tss1_module tss1 module documentation
**  @{
*/

/* MODULE tss1. */

#include "tss1.h"

/* This file is generated automatically by OS Interface layer and is intentionally
    left empty */


/*! tss1 Raw Layer configuration region */

/*! @brief Temporary Buffer define */
int16_t sampleBuffer[6UL];

/*! @brief Raw Layer state structure */
tss_raw_state_t tss1_RawState;

/*! @brief Raw Layer Electrode 0 configuration structure */
tss_raw_electrode_config_t tss1_ElectrodeConfig0_Config =
{
	.adcInstance   = 0UL,
	.channelConfig = &adc1_ChnConfig0,
	.portBase      = PORTA,
	.gpioBase      = PTA,
	.pinNumberElec = 15U,
	.pinNumberCext = 0U,
	.portMask      = (1UL << 0U) | (1UL << 15U)
};
/*! @brief Raw Layer Electrode 1 configuration structure */
tss_raw_electrode_config_t tss1_ElectrodeConfig1_Config =
{
	.adcInstance   = 0UL,
	.channelConfig = &adc1_ChnConfig1,
	.portBase      = PORTA,
	.gpioBase      = PTA,
	.pinNumberElec = 16U,
	.pinNumberCext = 1U,
	.portMask      = (1UL << 1U) | (1UL << 16U)
};

/*! @brief Raw Layer Electrode 0 state structure */
tss_raw_electrode_state_t tss1_ElectrodeConfig0_State;
/*! @brief Raw Layer Electrode 1 state structure */
tss_raw_electrode_state_t tss1_ElectrodeConfig1_State;

/*! @brief Raw Layer Electrodes Configuration Array */
tss_raw_electrode_config_t *electrodeRawConfigArr[2] =
{
	&tss1_ElectrodeConfig0_Config,
	&tss1_ElectrodeConfig1_Config,
};

/*! @brief Raw Layer Electrodes State Array */
tss_raw_electrode_state_t *electrodeRawStateArr[2] =
{
	&tss1_ElectrodeConfig0_State,
	&tss1_ElectrodeConfig1_State,
};

/*! @brief Raw Layer Configuration structure */
tss_raw_config_t  tss1_RawConfig =
{
	.electrodes               = electrodeRawConfigArr,
	.numberOfElectrodes       = 2U,
	.adcConfig                = &adc1_ConvConfig0,
	.lptmrConfig              = &lptmr1_config0,
	.lptmrInstance            = 0UL,
	.chargeDistributionPeriod = 0UL,
	.sensingCycles            = 4UL,
	.sensingPrecycles         = 2UL,
	.sampleBuffer             = sampleBuffer,
	.timerCallback            = NULL
};

/*! tss1 Filter & Decode Layer configuration region */

/*! @brief Filter and Decode Layer Filter 0 Configuration structure */
tss_filter_coeff_t tss1_FilterConfig0 =
{
  .a1 = -0.8257f,
  .b0 = 0.08717f,
  .b1 = 0.08717f
};

/*! @brief Filter and Decode Layer Electrode 0 configuration structure */
tss_electrode_filter_config_t tss1_FilterElecConfig0_Config =
{
  .touchThredsholdDelta = 20UL,
  .touchReleaseDelta    = 22UL,
  .dcTrackerFactor      = 8UL,
  .filterPtr            = &tss1_FilterConfig0
};
/*! @brief Filter and Decode Layer Electrode 1 configuration structure */
tss_electrode_filter_config_t tss1_FilterElecConfig1_Config =
{
  .touchThredsholdDelta = 20UL,
  .touchReleaseDelta    = 22UL,
  .dcTrackerFactor      = 8UL,
  .filterPtr            = &tss1_FilterConfig0
};

/*! @brief Filter and Decode Electrodes Config Array */
tss_electrode_filter_config_t *electrodeFDConfigArr[2] =
{
	&tss1_FilterElecConfig0_Config,
	&tss1_FilterElecConfig1_Config,
};

/*! @brief Filter and Decode Layer Electrode 0 configuration structure */
tss_electrode_filter_state_t tss1_FilterElecConfig0_State;
/*! @brief Filter and Decode Layer Electrode 1 configuration structure */
tss_electrode_filter_state_t tss1_FilterElecConfig1_State;

/*! @brief Filter and Decode Electrodes State Array */
tss_electrode_filter_state_t *electrodeFDStateArr[2] =
{
	&tss1_FilterElecConfig0_State,
	&tss1_FilterElecConfig1_State,
};


/*! @brief Filter and Decode Configuration structure */
tss_filter_config_t tss1_FilterDecodeConfig =
{
	.electrodesConfig      =  electrodeFDConfigArr,
	.numberOfElectrodes    =  2U,
	.wakeupEnable          =  false,
	.wakeupElectrodeNumber =  0U,
	.wakeupActivateCnt     =  50UL
};

/*! @brief Filter and Decode State structure */
tss_filter_state_t tss1_FilterDecodeState;

/* END tss1. */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.1 [05.21]
**     for the Freescale S32K series of microcontrollers.
**
** ###################################################################
*/

